//Mario's Ideas
//MAX7219 - using Led Control library to display all   leds one by one
#include "LedControl.h"

int DIN = 11;
int CS = 7;
int   CLK = 13;
int BUTTON = 4;
LedControl lc=LedControl(DIN, CLK, CS,0);

//button variables
bool buttonOn = false;
int buttonValue;

//variables to keep track of what leds to enable
int currentRow = 0;
int currentColumn = 0;
int currentDirection = 1;
int timer = 0;
int playingInt = -1; //current row the player is stackin on

//Some game variables
int resetDelayDuration = 1000;
int speedReduction = 10;
int currentSpeed = 100;
int startSpeed = 100;

bool isIngame = false;
int preGameScrollingOffset = 0;

bool winner = false;
int winnerScrollingOffset = 0;

int StackerMatrix[8][46] = {
  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,0,0,1,1,1,0,0,0,1,1,1,0,1,0,0,1,0,1,1,1,0,1,1,1,0,0,0,0,0,0},
  {0,0,1,1,0,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,1,0,0,0,0,1,0,1,0,0,1,0,0,0,1,0,0,1,0,1,1,0,0},
  {1,0,0,0,0,1,1,1,1,1,0,0,0,1,0,0,0,1,0,0,0,1,0,1,0,0,0,0,1,1,0,0,0,1,1,1,0,1,0,0,1,0,0,0,0,1},
  {0,0,1,1,0,0,0,0,0,1,0,0,0,1,0,0,0,1,1,1,1,1,0,1,0,0,0,0,1,0,1,0,0,1,0,0,0,1,1,1,0,0,1,1,0,0},
  {0,0,0,0,0,1,1,1,1,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,1,1,1,0,1,0,0,1,0,1,1,1,0,1,0,0,1,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
};

int WinnerMatrix[8][43] = {
  {1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1},
  {0,1,0,1,0,0,1,0,1,0,1,0,1,1,1,0,1,0,0,0,1,0,1,0,0,0,1,0,1,1,1,1,0,1,1,1,0,0,0,1,0,1,0},
  {1,0,1,0,1,0,1,0,1,0,1,0,0,1,0,0,1,1,0,0,1,0,1,1,0,0,1,0,1,0,0,0,0,1,0,0,1,0,1,0,1,0,1},
  {0,1,0,1,0,0,1,0,1,0,1,0,0,1,0,0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,1,0,0,1,0,0,1,0,0,1,0,1,0},
  {1,0,1,0,1,0,1,0,1,0,1,0,0,1,0,0,1,0,0,1,1,0,1,0,0,1,1,0,1,0,0,0,0,1,1,1,0,0,1,0,1,0,1},
  {0,1,0,1,0,0,0,1,0,1,0,0,1,1,1,0,1,0,0,0,1,0,1,0,0,0,1,0,1,1,1,1,0,1,0,0,1,0,0,1,0,1,0},
  {1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1},
  {0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0},
};

void setup()   {
  Serial.begin(9600);
  lc.shutdown(0,false);
  lc.setIntensity(0,0);
  lc.clearDisplay(0);
  pinMode(BUTTON, INPUT);

  //-----------------------------------------------
  //Set initial button value before the game starts
  InitializeButtonVariable();
  //-----------------------------------------------
}

void   loop() {
  //lc.setColumn(0, value, 0xFF);
  if(winner){
    if(ReadButtonInput()){
      ResetGame();
    }
    WinnerScreen();
  }
  else if(isIngame == false){
    PreGameLoop();
    if(ReadButtonInput()){
      lc.clearDisplay(0);
      isIngame = true;
    }
  }
  else{
    GameLoop();
  }
  delay(1);
}

void GameLoop(){
  //Draw next pixel based on game speed
  timer++;
  if(timer >= currentSpeed){
    NextLed();
  }
  
  //-----------------------------------
  if(ReadButtonInput()){
    NextColumn();  
  }

  if(currentColumn == 8){
    delay(resetDelayDuration);
    winner = true;
  }
}

void NextLed(){
  timer = 0;
  lc.setLed(0, currentRow, currentColumn, false);
  currentRow += currentDirection;
  if(currentRow == 7 || currentRow == 0){
    currentDirection = currentDirection * -1;
  }
  lc.setLed(0, currentRow, currentColumn, true);
}

void NextColumn(){
  currentColumn++;
  currentSpeed -= speedReduction;
  if(playingInt == -1){
    playingInt = currentRow;
  }
  else{
    if(playingInt != currentRow){
      ResetGame();
    }
  }
}

bool ReadButtonInput(){
  //read button value and change a switch to a click button
  buttonValue = digitalRead(BUTTON);
  if(buttonValue == HIGH){
    if(buttonOn == false){
      buttonOn = true;
      return true;
    }
    else{
      return false;
    }
  }
  else{
    if(buttonOn == true){
      buttonOn = false;
      return true;
    }
    else{
      return false;
    }
  }
}

void ResetGame(){
    delay(resetDelayDuration);
    lc.clearDisplay(0);
    currentColumn = 0;
    currentSpeed = startSpeed;
    InitializeButtonVariable();
    playingInt = -1;
    isIngame = false;
    preGameScrollingOffset = 0;
    winner = false;
    winnerScrollingOffset = 0;
}

void InitializeButtonVariable(){
  buttonValue = digitalRead(BUTTON);
  if(buttonValue == HIGH){
    buttonOn = true;
  }else{
    buttonOn = false;
  }
}

void PreGameLoop(){
  for(int j=0; j<8; j++){
    for(int i=0; i<8; i++){
      lc.setLed(0, i, 7-j, StackerMatrix[j][(i+preGameScrollingOffset)-abs((i+preGameScrollingOffset)/46)*46]);
    }
  }
  preGameScrollingOffset++;
}

void WinnerScreen(){
  for(int j=0; j<8; j++){
    for(int i=0; i<8; i++){
      lc.setLed(0, i, 7-j, WinnerMatrix[j][i + winnerScrollingOffset]);
    }
  }
  winnerScrollingOffset++;
  if(winnerScrollingOffset >= 36){
    ResetGame();
  }
}
